import javax.swing.*;
import java.awt.*;
import java.util.Random;
public class DrawningAirplaneWithRadar {
    JPanel AirplaneWithRadarPanel;
    private EntityAirplaneWithRadar EntityAirplaneWithRadar;
    private int _pictureWidth;
    private int _pictureHeight;
    private int _startPosX = 0;
    private int _startPosY = 0;
    private int _airplaneWidth = 200;
    private int _airplaneHeight = 78;
    private DrawningIlluminators DrawningIlluminators;
    public EntityAirplaneWithRadar EntityAirplaneWithRadar(){
        return EntityAirplaneWithRadar;
    }
    public boolean Init(int speed, double weight, Color bodyColor, Color illuminatorColor, Color additionalColor, int illuminatorNumb,
                        int width, int height, boolean radar, boolean dopBak, JPanel airplaneWithRadarPanel){
        if(width <= _airplaneWidth || height <= _airplaneHeight)
            return false;
        _startPosY=0;
        _startPosX = 0;
        airplaneWithRadarPanel.setSize(width, height);
        AirplaneWithRadarPanel = airplaneWithRadarPanel;
        airplaneWithRadarPanel.paint(AirplaneWithRadarPanel.getGraphics());
        _pictureWidth = width;
        _pictureHeight = height;
        EntityAirplaneWithRadar = new EntityAirplaneWithRadar();
        EntityAirplaneWithRadar.Init(speed, weight, bodyColor, illuminatorColor, additionalColor, illuminatorNumb, radar, dopBak);
        DrawningIlluminators = new DrawningIlluminators();
        DrawningIlluminators.Init(_airplaneWidth, _airplaneHeight,_startPosX,_startPosY,illuminatorColor,airplaneWithRadarPanel);
        Random rand = new Random();
        DrawningIlluminators.ChangeIlluminatorNumb(rand.nextInt(1, 5));
        return true;
    }
    public void SetPosition(int x, int y){
        if (x < 0 || y < 0 || x + _airplaneWidth >= _pictureWidth || y + _airplaneHeight >= _pictureHeight)
        {
            x = y = 10;
            _startPosX = x;
            _startPosY = y;
        }
        _startPosX = x;
        _startPosY = y;
        DrawningIlluminators.CurX = _startPosX;
        DrawningIlluminators.CurY = _startPosY;
    }
    public void MoveTransport(DirectionType direction){
        if (EntityAirplaneWithRadar == null)
            return;
        AirplaneWithRadarPanel.paint(AirplaneWithRadarPanel.getGraphics());
        switch (direction)
        {
            case Left:
                if (_startPosX - EntityAirplaneWithRadar.Step() >= 0)
                    _startPosX -= (int)EntityAirplaneWithRadar.Step();
                else
                    _startPosX = 0;
                break;
            case Up:
                if (_startPosY - EntityAirplaneWithRadar.Step() >= 0)
                    _startPosY -= (int)EntityAirplaneWithRadar.Step();
                else
                    _startPosY = 0;
                break;
            case Right:
                if (_startPosX + EntityAirplaneWithRadar.Step() + _airplaneWidth < _pictureWidth)
                    _startPosX += (int)EntityAirplaneWithRadar.Step();
                else
                    _startPosX = _pictureWidth - _airplaneWidth;
                break;
            case Down:
                if (_startPosY + EntityAirplaneWithRadar.Step() + _airplaneHeight < _pictureHeight)
                    _startPosY += (int)EntityAirplaneWithRadar.Step();
                else
                    _startPosY = _pictureHeight - _airplaneHeight;
                break;
        }
        DrawningIlluminators.CurX = _startPosX;
        DrawningIlluminators.CurY = _startPosY;
    }
    public void DrawAirplaneWithRadar(){
        Graphics2D g2d = (Graphics2D)AirplaneWithRadarPanel.getGraphics();
        if (EntityAirplaneWithRadar == null)
            return;
        g2d.setColor(Color.BLACK);
        g2d.setStroke(new BasicStroke(3));
// корпус
        g2d.setColor(EntityAirplaneWithRadar.BodyColor());
        g2d.fillOval(_startPosX, _startPosY + 25, 180, 30);
        g2d.setColor(Color.BLACK);
        g2d.drawOval(_startPosX, _startPosY + 25, 180, 30);
// крыло
        g2d.setColor(Color.BLACK);
        g2d.fillOval(_startPosX + 70, _startPosY + 35, 80, 10);
// стекла
        g2d.setColor(Color.BLUE);
        int[] curvePointsX =
                {
                        _startPosX + 170,
                        _startPosX + 200,
                        _startPosX + 170,
                };
        int[] curvePointsY =
                {
                        _startPosY + 30,
                        _startPosY + 40,
                        _startPosY + 50,
                };
        g2d.fillPolygon(curvePointsX,curvePointsY,curvePointsY.length);
        g2d.setColor(Color.BLACK);
        g2d.drawPolygon(curvePointsX,curvePointsY,curvePointsY.length);
        g2d.drawLine(_startPosX + 170, _startPosY + 40, _startPosX + 200, _startPosY + 40);
// хвост
        g2d.setColor(Color.BLUE);
        int[] curvePoints2x =
                {
                        _startPosX,
                        _startPosX,
                        _startPosX + 30,
                };
        int[] curvePoints2y =
                {
                        _startPosY + 35,
                        _startPosY + 5,
                        _startPosY + 35,
                };
        g2d.fillPolygon(curvePoints2x,curvePoints2y, curvePoints2x.length);
        g2d.setColor(Color.BLACK);
        g2d.drawPolygon(curvePoints2x,curvePoints2y, curvePoints2x.length);
// шасси
        g2d.setColor(Color.BLACK);
        g2d.drawLine(_startPosX + 50, _startPosY + 55, _startPosX + 50, _startPosY + 70);
        g2d.drawLine(_startPosX + 150, _startPosY + 51, _startPosX + 150, _startPosY + 70);
        g2d.fillOval(_startPosX + 40, _startPosY + 65, 10, 10);
        g2d.fillOval(_startPosX + 50, _startPosY + 65, 10, 10);
        g2d.fillOval(_startPosX + 145, _startPosY + 65, 10, 10);
//дополнительный бак
        if (EntityAirplaneWithRadar().DopBak()) {
            g2d.setColor(EntityAirplaneWithRadar.AdditionalColor());
            g2d.fillOval( _startPosX, _startPosY + 45, 40, 20);
            g2d.setColor(Color.BLACK);
            g2d.drawOval(_startPosX, _startPosY + 45, 40, 20);
        }
//радар
        if (EntityAirplaneWithRadar.Radar())
        {
            g2d.setColor(Color.BLACK);
            g2d.drawLine(_startPosX + 60, _startPosY + 25, _startPosX + 60, _startPosY + 15);
            g2d.drawLine( _startPosX + 60, _startPosY + 15, _startPosX + 67, _startPosY + 11);
            g2d.setColor(EntityAirplaneWithRadar.AdditionalColor());
            Point point7 = new Point(_startPosX + 60, _startPosY + 15);
            Point point8 = new Point(_startPosX + 60, _startPosY + 5);
            Point point9 = new Point(_startPosX + 70, _startPosY + 25);
            int[] curvePoints3x =
                    {
                            _startPosX + 60,
                            _startPosX + 60,
                            _startPosX + 70,
                    };
            int[] curvePoints3y =
                    {
                            _startPosY + 15,
                            _startPosY + 5,
                            _startPosY + 25,
                    };
            g2d.fillPolygon(curvePoints3x, curvePoints3y,curvePoints3x.length);
        }
        DrawningIlluminators.DrawIlluminators();
    }
}
